#ifndef TERSE_H
#define TERSE_H


inline 
void TerselyPrintSignalElements(FILE *outFD, Signal *sig,
				struct timeval sigTime, void *buffer)
{
  
    TypeID type = SignalGetType(sig);
    int len = SignalGetLength(sig,1);
    int units = SignalGetUnitSamples(sig);
    int totLen = len*units;
    int i;

    //enchantment only handles the first dimension for now

    fprintf(outFD, "%06ld.%06ld", sigTime.tv_sec, sigTime.tv_usec);  
 
    for(i = 0; i < totLen; i++)
    {
        if ((type & T_NUMERIC_FORMAT_MASK) == T_FLOAT_FORMAT)
        {
            if ((type & 0x0003) == 0x0003)   // this is ugly, but HasFormat(type, T_DOUBLE) from types.h does not work!
            {
                fprintf(outFD, " %g", ((double *)buffer)[i]);
            }
            else if ((type & 0x0003) == 0x0002)   // this is ugly, but HasFormat(type, T_DOUBLE) from types.h does not work!
            {
                fprintf(outFD, " %g", ((float *)buffer)[i]);
            }
        }
        else
        {  
            int elsize;
            long val;
            if ((type&3) == 0) {
                elsize = 1;
                val = ((signed char *)buffer)[i];
            } else if ((type&3) == 1) {
                val = ((signed short *)buffer)[i];
                elsize = 2;
            } else if ((type&3) == 2) {
                val = ((long *)buffer)[i];
                elsize = 4;
            }

            if ((type & T_NUMERIC_FORMAT_MASK) == T_INT_FORMAT)
                fprintf(outFD, " %ld", val);
            else if ((type & T_NUMERIC_FORMAT_MASK) == T_FIXED_FORMAT)
                fprintf(outFD, " %g", val/((double) ((long long) 1 << (elsize << 2))));
            else if ((type & T_NUMERIC_FORMAT_MASK) == T_FRACTION_FORMAT)
                fprintf(outFD, " %g", val/((double) ((long long) 1 << (elsize << 3))));
        }
    }
    
    fprintf(outFD, "\n");
}

#endif
