/*************************************************
 * File: protocol.c
 * Author: Daniel Barkalow
 * Birth Date: 5/19/04
 *
 * Project: Enchantment IPC
 * 
 * Based on Enchantment IPC Whitepaper
 *   by Edward Keyes.
 * 
 * Copyright (C) 2004 AWare Technologies, Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 *************************************************/

#include "protocol.h"

IntroFormat protocolInteraction = { PROTOCOL_TYPE, 0, T_STRING };

IntroFormat protocolEncrypt = { PROTOCOL_ENCRYPT, 0, T_STRING };

IntroFormat *clientCommonProperties[] =
{
  &protocolInteraction,
  &protocolEncrypt,
  NULL
};

IntroFormat *serverCommonProperties[] =
{
  &protocolInteraction,
  &protocolEncrypt,
  NULL
};

IntroFormat *whiteboardClientProperties[] =
{
  NULL
};

IntroFormat signalUNL = { PROTOCOL_SIGNAL_UNL, 0, T_STRING };

IntroFormat signalType = { PROTOCOL_SIGNAL_TYPE, 0, T_INT32 };

IntroFormat signalEltsize = { PROTOCOL_SIGNAL_ELTSIZE, 0, T_INT32 };

IntroFormat signalLength = { PROTOCOL_SIGNAL_LENGTH, 1, T_INT32 };

IntroFormat signalLabel = { PROTOCOL_SIGNAL_LABEL, 1, T_STRING };

IntroFormat signalIndexLabel = { PROTOCOL_SIGNAL_INDEX_LABEL, 1, T_STRING };

IntroFormat signalRate = { PROTOCOL_SIGNAL_SAMPLE_RATE, 1, T_INT32 };

IntroFormat *generatorProperties[] =
{
  &signalType, 
  &signalEltsize,
  &signalLength,
  &signalLabel,
  &signalIndexLabel,
  &signalRate,
  &protocolEncrypt,
  &protocolInteraction,
  NULL
};

IntroFormat *receiverProperties[] =
{
  &protocolEncrypt,
  &protocolInteraction,
  &signalUNL,
  NULL
};
